from resources.lib.toollib import *
import xbmcgui

ADDON_PROFILE = xbmc.translatePath(ADDON.getAddonInfo('Profile'))
jIO = jsonIO(ADDON_PROFILE, 'bingelist.json')
kl = KodiLib()


def bool2string(boolean, string4true, string4false):
    if boolean: return string4true
    return string4false


class ContextHandler():

    def __init__(self):
        self.bl_list = jIO.read()

    def create_bingelist(self):
        _li = []
        _idx = 0
        for bl_item in self.bl_list:
            liz = xbmcgui.ListItem(label=bl_item['item'].get('title', 'undefined'),
                                   label2=bool2string(bl_item['item'].get('has_played', False), ADDON_LOC(32001), ADDON_LOC(32002)),
                                   iconImage=bl_item['item'].get('thumb', xbmcgui.ICON_TYPE_VIDEOS))
            liz.setProperty('idx', str(_idx))
            _li.append(liz)
            _idx += 1
        return _li

    def binge_player(self, entry=0):
        player = xbmc.Player()
        monitor = xbmc.Monitor()
        for idx in range(entry, len(self.bl_list)):
            bl_item = self.bl_list[idx]
            if not bl_item['item'].get('has_played', False):

                # play video
                kl.writeLog('Playing \'%s\'' % bl_item['item'].get('title'))
                player.play(bl_item['item'].get('path', None))

                while not monitor.waitForAbort(2):
                    if player.isPlaying():
                        if bl_item['item'].get('total_time', 0) == 0:
                            bl_item['item'].update({'total_time': player.getTotalTime()})
                        bl_item['item'].update({'position': player.getTime()})
                    else:
                        break

                bl_item['item'].update({'has_played': True})
                jIO.write(self.bl_list)



    def add_item(self):
        bl_item = dict()
        bl_item.update({'item': {'path': xbmc.getInfoLabel('ListItem.FilenameAndPath'),
                                 'title': xbmc.getInfoLabel('ListItem.Label'),
                                 'thumb': xbmc.getInfoLabel('ListItem.Thumb'),
                                 'has_played': False,
                                 'position': 0,
                                 'total_time': 0}})
        self.bl_list.append(bl_item)
        jIO.write(self.bl_list)
        kl.writeLog('\'%s\' added as %s. item to binge list' % (bl_item['item'].get('title'), len(self.bl_list)))


    def play_all(self):
        self.binge_player(entry=0)


    def play_item(self):
        _li = self.create_bingelist()
        _idx = xbmcgui.Dialog().select(ADDON_LOC(32000), _li, useDetails=True)
        if _idx > -1:
            kl.writeLog('Play from pos %s' % (_idx + 1))
            self.binge_player(entry=_idx)


    def mark_item(self):
        _li = self.create_bingelist()
        _idx = xbmcgui.Dialog().select(ADDON_LOC(32000), _li, useDetails=True)
        if _idx > -1:
            bl_item = self.bl_list[_idx]
            kl.writeLog('Toggle item at pos %s' % (_idx + 1))
            _current = bl_item['item'].get('has_played', False)
            print str(_current)
            bl_item['item'].update({'has_played': not _current})
            jIO.write(self.bl_list)

    def clear_all(self):
        jIO.delete()
        kl.writeLog('Binge list deleted')


if __name__ == '__main__':
    pass